com.fasterxml.jackson.databind.ser

## Class BeanSerializer

- java.lang.Object
- - com.fasterxml.jackson.databind.JsonSerializer<T>
  - - com.fasterxml.jackson.databind.ser.std.StdSerializer<Object>
    - - com.fasterxml.jackson.databind.ser.std.BeanSerializerBase
      - - com.fasterxml.jackson.databind.ser.BeanSerializer

All Implemented Interfaces:
  JsonFormatVisitable, SchemaAware, ContextualSerializer, ResolvableSerializer, Serializable

    public class BeanSerializer
    extends BeanSerializerBase

Serializer class that can serialize Java objects that map to JSON Object output. Internally handling is mostly dealt with by a sequence of `BeanPropertyWriter`s that will handle access value to serialize and call appropriate serializers to write out JSON.

Implementation note: we will post-process resulting serializer, to figure out actual serializers for final types. This must be done from `BeanSerializerBase.resolve(com.fasterxml.jackson.databind.SerializerProvider)` method, and NOT from constructor; otherwise we could end up with an infinite loop.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class com.fasterxml.jackson.databind.JsonSerializer

`JsonSerializer.None`

### Field Summary

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.BeanSerializerBase

`_anyGetterWriter, _filteredProps, _objectIdWriter, _propertyFilterId, _props, _serializationShape, _typeId, NAME_FOR_OBJECT_REF, NO_PROPS`

### Fields inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`_handledType`

### Constructor Summary

Constructors
`protected` `BeanSerializer(BeanSerializerBase src)` Alternate copy constructor that can be used to construct standard `BeanSerializer` passing an instance of "compatible enough" source serializer.
`protected` `BeanSerializer(BeanSerializerBase src, ObjectIdWriter objectIdWriter)`
`protected` `BeanSerializer(BeanSerializerBase src, ObjectIdWriter objectIdWriter, Object filterId)`
`protected` `BeanSerializer(BeanSerializerBase src, Set<String> toIgnore)`
`` `BeanSerializer(JavaType type, BeanSerializerBuilder builder, BeanPropertyWriter[] properties, BeanPropertyWriter[] filteredProperties)`

### Method Summary

Methods
`protected BeanSerializerBase` `asArraySerializer()` Implementation has to check whether as-array serialization is possible reliably; if (and only if) so, will construct a `BeanAsArraySerializer`, otherwise will return this serializer as is.
`static BeanSerializer` `createDummy(JavaType forType)` Method for constructing dummy bean serializer; one that never outputs any properties
`void` `serialize(Object bean, JsonGenerator gen, SerializerProvider provider)` Main serialization method that will delegate actual output to configured `BeanPropertyWriter` instances.
`String` `toString()`
`JsonSerializer<Object>` `unwrappingSerializer(NameTransformer unwrapper)` Method that will return serializer instance that produces "unwrapped" serialization, if applicable for type being serialized (which is the case for some serializers that produce JSON Objects as output).
`BeanSerializerBase` `withFilterId(Object filterId)` Mutant factory used for creating a new instance with different filter id (used with `JsonFilter` annotation)
`protected BeanSerializerBase` `withIgnorals(Set<String> toIgnore)` Mutant factory used for creating a new instance with additional set of properties to ignore (from properties this instance otherwise has)
`BeanSerializerBase` `withObjectIdWriter(ObjectIdWriter objectIdWriter)` Mutant factory used for creating a new instance with different `ObjectIdWriter`.

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.BeanSerializerBase

`_customTypeId, _serializeObjectId, _serializeWithObjectId, _serializeWithObjectId, acceptJsonFormatVisitor, createContextual, findConvertingSerializer, getSchema, properties, resolve, serializeFields, serializeFieldsFiltered, serializeWithType, usesObjectId, withIgnorals`

### Methods inherited from class com.fasterxml.jackson.databind.ser.std.StdSerializer

`createObjectNode, createSchemaNode, createSchemaNode, findAnnotatedContentSerializer, findConvertingContentSerializer, findFormatFeature, findFormatOverrides, findIncludeOverrides, findPropertyFilter, getSchema, handledType, isDefaultSerializer, visitArrayFormat, visitArrayFormat, visitFloatFormat, visitIntFormat, visitIntFormat, visitStringFormat, visitStringFormat, wrapAndThrow, wrapAndThrow`

### Methods inherited from class com.fasterxml.jackson.databind.JsonSerializer

`getDelegatee, isEmpty, isEmpty, isUnwrappingSerializer, replaceDelegatee`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface com.fasterxml.jackson.databind.jsonschema.SchemaAware

`getSchema`

### Constructor Detail

#### BeanSerializer

    public BeanSerializer(JavaType type,
                  BeanSerializerBuilder builder,
                  BeanPropertyWriter[] properties,
                  BeanPropertyWriter[] filteredProperties)

Parameters:
  `builder` - Builder object that contains collected information that may be needed for serializer
  `properties` - Property writers used for actual serialization

#### BeanSerializer

    protected BeanSerializer(BeanSerializerBase src)

Alternate copy constructor that can be used to construct standard `BeanSerializer` passing an instance of "compatible enough" source serializer.

#### BeanSerializer

    protected BeanSerializer(BeanSerializerBase src,
                  ObjectIdWriter objectIdWriter)

#### BeanSerializer

    protected BeanSerializer(BeanSerializerBase src,
                  ObjectIdWriter objectIdWriter,
                  Object filterId)

#### BeanSerializer

    protected BeanSerializer(BeanSerializerBase src,
                  Set<String> toIgnore)

### Method Detail

#### createDummy

    public static BeanSerializer createDummy(JavaType forType)

Method for constructing dummy bean serializer; one that never outputs any properties

#### unwrappingSerializer

    public JsonSerializer<Object> unwrappingSerializer(NameTransformer unwrapper)

Description copied from class: `JsonSerializer`
Method that will return serializer instance that produces "unwrapped" serialization, if applicable for type being serialized (which is the case for some serializers that produce JSON Objects as output). If no unwrapped serializer can be constructed, will simply return serializer as-is.

Default implementation just returns serializer as-is, indicating that no unwrapped variant exists

Overrides:
  `unwrappingSerializer` in class `JsonSerializer<Object>`
Parameters:
  `unwrapper` - Name transformation to use to convert between names of unwrapper properties

#### withObjectIdWriter

    public BeanSerializerBase withObjectIdWriter(ObjectIdWriter objectIdWriter)

Description copied from class: `BeanSerializerBase`
Mutant factory used for creating a new instance with different `ObjectIdWriter`.

Specified by:
  `withObjectIdWriter` in class `BeanSerializerBase`

#### withFilterId

    public BeanSerializerBase withFilterId(Object filterId)

Description copied from class: `BeanSerializerBase`
Mutant factory used for creating a new instance with different filter id (used with `JsonFilter` annotation)

Specified by:
  `withFilterId` in class `BeanSerializerBase`

#### withIgnorals

    protected BeanSerializerBase withIgnorals(Set<String> toIgnore)

Description copied from class: `BeanSerializerBase`
Mutant factory used for creating a new instance with additional set of properties to ignore (from properties this instance otherwise has)

Specified by:
  `withIgnorals` in class `BeanSerializerBase`

#### asArraySerializer

    protected BeanSerializerBase asArraySerializer()

Implementation has to check whether as-array serialization is possible reliably; if (and only if) so, will construct a `BeanAsArraySerializer`, otherwise will return this serializer as is.

Specified by:
  `asArraySerializer` in class `BeanSerializerBase`

#### serialize

    public final void serialize(Object bean,
                 JsonGenerator gen,
                 SerializerProvider provider)
                         throws IOException

Main serialization method that will delegate actual output to configured `BeanPropertyWriter` instances.

Specified by:
  `serialize` in class `BeanSerializerBase`
Parameters:
  `bean` - Value to serialize; can not be null.
  `gen` - Generator used to output resulting Json content
  `provider` - Provider that can be used to get serializers for serializing Objects value contains, if any.
Throws:
  `IOException`

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`